# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free

Name:           apache-mime4j
Version:        0.7.2
Release:        1%{?dist}
Epoch:          0
Summary:        Mime stream parser
Group:          Development/Libraries/Java
License:        Apache Software License 2.0
URL:            http://james.apache.org/mime4j
Source0:        http://www.apache.org/dist/james/mime4j/apache-mime4j-project-0.7.2-source-release.zip
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml
Patch0:         %{name}-pom.patch

Requires:       jpackage-utils
BuildRequires:  apache-jar-resource-bundle >= 0:1.3
BuildRequires:  james-project >= 0:1.2
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-shared-downloader
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  mojo-maven2-plugin-javacc
BuildRequires:  felix-maven2
BuildRequires:  apache-commons-parent
BuildRequires:  apache-commons-io
BuildRequires:  apache-commons-logging
BuildRequires:  junit44
BuildRequires:  log4j
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Requires:       apache-commons-logging
Requires:       java >= 0:1.6.0

%description
Apache Mime4j is developed by the Apache James team but now
has a dedicated mailing list.
mime4j provides a parser, MimeStreamParser, for e-mail 
message streams in plain rfc822 and MIME format. The parser 
uses a callback mechanism to report parsing events such as 
the start of an entity header, the start of a body, etc. If 
you are familiar with the SAX XML parser interface you 
should have no problem getting started with mime4j.
The parser only deals with the structure of the message 
stream. It won't do any decoding of base64 or quoted-printable 
encoded header fields and bodies. This is intentional - the 
parser should only provide the most basic functionality needed 
to build more complex parsers. However, mime4j does include 
facilities to decode bodies and fields and the Message class 
described below handles decoding of fields and bodies 
transparently. 

%package        devel
Summary:        Source archives for %{name}
Group:          Development/Archives

%description    devel
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n apache-mime4j-project-%{version}
%patch0 -b .sav0
cp -p %{SOURCE2} maven2-settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml
mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/sources
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-project.pom
%add_to_maven_depmap org.apache.james apache-mime4j-project %{version} JPP/%{name} project

install -m 644 core/target/%{name}-core-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
ln -s %{_javadir}/%{name}/core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 core/target/%{name}-core-%{version}-tests.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/core-tests-%{version}.jar
install -m 644 core/target/%{name}-core-%{version}-sources.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/sources/core-%{version}.jar
install -m 644 core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
%add_to_maven_depmap org.apache.james apache-mime4j-core %{version} JPP/%{name} core

install -m 644 dom/target/%{name}-dom-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/dom-%{version}.jar
install -m 644 dom/target/%{name}-dom-%{version}-sources.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/sources/dom-%{version}.jar
install -m 644 dom/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dom.pom
%add_to_maven_depmap org.apache.james apache-mime4j-dom %{version} JPP/%{name} dom

install -m 644 storage/target/%{name}-storage-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/storage-%{version}.jar
install -m 644 storage/target/%{name}-storage-%{version}-tests.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/storage-tests-%{version}.jar
install -m 644 storage/target/%{name}-storage-%{version}-sources.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/sources/storage-%{version}.jar
install -m 644 storage/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-storage.pom
%add_to_maven_depmap org.apache.james apache-mime4j-storage %{version} JPP/%{name} storage

install -m 644 benchmark/target/%{name}-benchmark-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/benchmark-%{version}.jar
install -m 644 benchmark/target/%{name}-benchmark-%{version}-sources.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/sources/benchmark-%{version}.jar
install -m 644 benchmark/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-benchmark.pom
%add_to_maven_depmap org.apache.james apache-mime4j-benchmark %{version} JPP/%{name} benchmark

install -m 644 examples/target/%{name}-examples-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/examples-%{version}.jar
install -m 644 examples/target/%{name}-examples-%{version}-sources.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/sources/examples-%{version}.jar
install -m 644 examples/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-examples.pom
%add_to_maven_depmap org.apache.james apache-mime4j-examples %{version} JPP/%{name} examples

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/sources && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*.pom
%{_mavendepmapfragdir}/%{name}

%files devel
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}/sources
%{_javadir}/%{name}/sources/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Tue Mar 06 2012 Ralph Apel <r.apel@r-apel.de> 0.7.2-1
- 0.7.2 for JPP-6

* Tue Dec 14 2010 David Walluck <dwalluck@redhat.com> 0:0.6-2
- build with external apache-jar-resource-bundle-1.3
- build with external james-project-1.2
- remove BuildRequires: junit44

* Sat Oct 16 2010 Ralph Apel <r.apel@r-apel.de> 0.6-1
- first release

